//! This file is part of Flight.
//! 
//! Flight is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//! 
//! Flight is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//! You should have received a copy of the GNU General Public License along with Flight. If not, see <https://www.gnu.org/licenses/>.

// FFI for SDL2 key codes.

#![allow(unused)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]

#[repr(i32)] #[derive(Copy, Clone, Debug, Eq, PartialEq)] pub enum SDL_KeyCode {
	// (1<<30) is SDLK_SCANCODE_MASK, the original header uses a macro to add this to scancodes
	Unknown = 0,
	Return = 13,
	Escape = 27,
	Backspace = 8,
	Tab = 9,
	Space = ' ' as i32,
	Exclaim = '!' as i32,
	QuoteDbl = '"' as i32,
	Hash = '#' as i32,
	Percent = '%' as i32,
	Dollar = '$' as i32,
	Ampersand = '&' as i32,
	Quote = '\'' as i32,
	LeftParen = '(' as i32,
	RightParen = ')' as i32,
	Asterisk = '*' as i32,
	Plus = '+' as i32,
	Comma = ',' as i32,
	Minus = '-' as i32,
	Period = '.' as i32,
	Slash = '/' as i32,
	N0 = '0' as i32,
	N1 = '1' as i32,
	N2 = '2' as i32,
	N3 = '3' as i32,
	N4 = '4' as i32,
	N5 = '5' as i32,
	N6 = '6' as i32,
	N7 = '7' as i32,
	N8 = '8' as i32,
	N9 = '9' as i32,
	Colon = ':' as i32,
	Semicolon = ';' as i32,
	Less = '<' as i32,
	Equals = '=' as i32,
	Greater = '>' as i32,
	Question = '?' as i32,
	At = '@' as i32,
	LeftBracket = '[' as i32,
	Backslash = '\\' as i32,
	RightBracket = ']' as i32,
	Caret = '^' as i32,
	Underscore = '_' as i32,
	Backquote = '`' as i32,
	A = 'a' as i32,
	B = 'b' as i32,
	C = 'c' as i32,
	D = 'd' as i32,
	E = 'e' as i32,
	F = 'f' as i32,
	G = 'g' as i32,
	H = 'h' as i32,
	I = 'i' as i32,
	J = 'j' as i32,
	K = 'k' as i32,
	L = 'l' as i32,
	M = 'm' as i32,
	N = 'n' as i32,
	O = 'o' as i32,
	P = 'p' as i32,
	Q = 'q' as i32,
	R = 'r' as i32,
	S = 's' as i32,
	T = 't' as i32,
	U = 'u' as i32,
	V = 'v' as i32,
	W = 'w' as i32,
	X = 'x' as i32,
	Y = 'y' as i32,
	Z = 'z' as i32,
	Capslock = (1<<30)|57,
	F1 = (1<<30)|58,
	F2 = (1<<30)|59,
	F3 = (1<<30)|60,
	F4 = (1<<30)|61,
	F5 = (1<<30)|62,
	F6 = (1<<30)|63,
	F7 = (1<<30)|64,
	F8 = (1<<30)|65,
	F9 = (1<<30)|66,
	F10 = (1<<30)|67,
	F11 = (1<<30)|68,
	F12 = (1<<30)|69,
	PrintScreen = (1<<30)|70,
	ScrollLock = (1<<30)|71,
	Pause = (1<<30)|72,
	Insert = (1<<30)|73,
	Home = (1<<30)|74,
	PageUp = (1<<30)|75,
	Delete = 127,
	End = (1<<30)|77,
	PageDown = (1<<30)|78,
	Right = (1<<30)|79,
	Left = (1<<30)|80,
	Down = (1<<30)|81,
	Up = (1<<30)|82,
	NumlockClear = (1<<30)|83,
	KP_Divide = (1<<30)|84,
	KP_Multiply = (1<<30)|85,
	KP_Minus = (1<<30)|86,
	KP_Plus = (1<<30)|87,
	KP_Enter = (1<<30)|88,
	KP_1 = (1<<30)|89,
	KP_2 = (1<<30)|90,
	KP_3 = (1<<30)|91,
	KP_4 = (1<<30)|92,
	KP_5 = (1<<30)|93,
	KP_6 = (1<<30)|94,
	KP_7 = (1<<30)|95,
	KP_8 = (1<<30)|96,
	KP_9 = (1<<30)|97,
	KP_0 = (1<<30)|98,
	KP_Period = (1<<30)|99,
	Application = (1<<30)|101,
	Power = (1<<30)|102,
	KP_Equals = (1<<30)|103,
	F13 = (1<<30)|104,
	F14 = (1<<30)|105,
	F15 = (1<<30)|106,
	F16 = (1<<30)|107,
	F17 = (1<<30)|108,
	F18 = (1<<30)|109,
	F19 = (1<<30)|110,
	F20 = (1<<30)|111,
	F21 = (1<<30)|112,
	F22 = (1<<30)|113,
	F23 = (1<<30)|114,
	F24 = (1<<30)|115,
	Execute = (1<<30)|116,
	Help = (1<<30)|117,
	Menu = (1<<30)|118,
	Select = (1<<30)|119,
	Stop = (1<<30)|120,
	Again = (1<<30)|121,
	Undo = (1<<30)|122,
	Cut = (1<<30)|123,
	Copy = (1<<30)|124,
	Paste = (1<<30)|125,
	Find = (1<<30)|126,
	Mute = (1<<30)|127,
	VolumeUp = (1<<30)|128,
	VolumeDown = (1<<30)|129,
	KP_Comma = (1<<30)|133,
	KP_EqualsAS400 = (1<<30)|134,
	AltErase = (1<<30)|153,
	SysReq = (1<<30)|154,
	Cancel = (1<<30)|155,
	Clear = (1<<30)|156,
	Prior = (1<<30)|157,
	Return2 = (1<<30)|158,
	Separator = (1<<30)|159,
	Out = (1<<30)|160,
	Oper = (1<<30)|161,
	ClearAgain = (1<<30)|162,
	CRSEL = (1<<30)|163,
	EXSEL = (1<<30)|164,
	KP_00 = (1<<30)|176,
	KP_000 = (1<<30)|177,
	ThousandsSeparator = (1<<30)|178,
	DecimalSeparator = (1<<30)|179,
	CurrencyUnit = (1<<30)|180,
	CurrencySubunit = (1<<30)|181,
	KP_LeftParen = (1<<30)|182,
	KP_RightParen = (1<<30)|183,
	KP_LeftBrace = (1<<30)|184,
	KP_RightBrace = (1<<30)|185,
	KP_Tab = (1<<30)|186,
	KP_Backspace = (1<<30)|187,
	KP_A = (1<<30)|188,
	KP_B = (1<<30)|189,
	KP_C = (1<<30)|190,
	KP_D = (1<<30)|191,
	KP_E = (1<<30)|192,
	KP_F = (1<<30)|193,
	KP_Xor = (1<<30)|194,
	KP_Power = (1<<30)|195,
	KP_Percent = (1<<30)|196,
	KP_Less = (1<<30)|197,
	KP_Greater = (1<<30)|198,
	KP_Ampersand = (1<<30)|199,
	KP_DblAmpersand = (1<<30)|200,
	KP_VerticalBar = (1<<30)|201,
	KP_DblVerticalBar = (1<<30)|202,
	KP_Colon = (1<<30)|203,
	KP_Hash = (1<<30)|204,
	KP_Space = (1<<30)|205,
	KP_At = (1<<30)|206,
	KP_Exclam = (1<<30)|207,
	KP_MemStore = (1<<30)|208,
	KP_MemRecall = (1<<30)|209,
	KP_MemClear = (1<<30)|210,
	KP_MemAdd = (1<<30)|211,
	KP_MemSubtract = (1<<30)|212,
	KP_MemMultiply = (1<<30)|213,
	KP_MemDivide = (1<<30)|214,
	KP_PlusMinus = (1<<30)|215,
	KP_Clear = (1<<30)|216,
	KP_ClearEntry = (1<<30)|217,
	KP_Binary = (1<<30)|218,
	KP_Octal = (1<<30)|219,
	KP_Decimal = (1<<30)|220,
	KP_Hexadecimal = (1<<30)|221,
	LCtrl = (1<<30)|224,
	LShift = (1<<30)|225,
	LAlt = (1<<30)|226,
	LGui = (1<<30)|227,
	RCtrl = (1<<30)|228,
	RShift = (1<<30)|229,
	RAlt = (1<<30)|230,
	RGui = (1<<30)|231,
	Mode = (1<<30)|257,
	AudioNext = (1<<30)|258,
	AudioPrev = (1<<30)|259,
	AudioStop = (1<<30)|260,
	AudioPlay = (1<<30)|261,
	AudioMute = (1<<30)|262,
	MediaSelect = (1<<30)|263,
	WWW = (1<<30)|264,
	Mail = (1<<30)|265,
	Calculator = (1<<30)|266,
	Computer = (1<<30)|267,
	AC_Search = (1<<30)|268,
	AC_Home = (1<<30)|269,
	AC_Back = (1<<30)|270,
	AC_Forward = (1<<30)|271,
	AC_Stop = (1<<30)|272,
	AC_Refresh = (1<<30)|273,
	AC_Bookmarks = (1<<30)|274,
	BrightnessDown = (1<<30)|275,
	BrightnessUp = (1<<30)|276,
	DisplaySwitch = (1<<30)|277,
	KbdIllumToggle = (1<<30)|278,
	KbdIllumDown = (1<<30)|279,
	KbdIllumUp = (1<<30)|280,
	Eject = (1<<30)|281,
	Sleep = (1<<30)|282,
	App1 = (1<<30)|283,
	App2 = (1<<30)|284,
	AudioRewind = (1<<30)|285,
	AudioFastforward = (1<<30)|286,
}

#[repr(C)] #[derive(Copy, Clone, Debug, Eq, PartialEq)] pub enum SDL_Scancode {
	Unknown = 0,
	A = 4,
	B = 5,
	C = 6,
	D = 7,
	E = 8,
	F = 9,
	G = 10,
	H = 11,
	I = 12,
	J = 13,
	K = 14,
	L = 15,
	M = 16,
	N = 17,
	O = 18,
	P = 19,
	Q = 20,
	R = 21,
	S = 22,
	T = 23,
	U = 24,
	V = 25,
	W = 26,
	X = 27,
	Y = 28,
	Z = 29,
	N1 = 30,
	N2 = 31,
	N3 = 32,
	N4 = 33,
	N5 = 34,
	N6 = 35,
	N7 = 36,
	N8 = 37,
	N9 = 38,
	N0 = 39,
	Return = 40,
	Escape = 41,
	Backspace = 42,
	Tab = 43,
	Space = 44,
	Minus = 45,
	Equals = 46,
	LeftBracket = 47,
	RightBracket = 48,
	Backslash = 49,
	NonUSHash = 50,
	Semicolon = 51,
	Apostrophe = 52,
	Grave = 53,
	Comma = 54,
	Period = 55,
	Slash = 56,
	Capslock = 57,
	F1 = 58,
	F2 = 59,
	F3 = 60,
	F4 = 61,
	F5 = 62,
	F6 = 63,
	F7 = 64,
	F8 = 65,
	F9 = 66,
	F10 = 67,
	F11 = 68,
	F12 = 69,
	PrintScreen = 70,
	ScrollLock = 71,
	Pause = 72,
	Insert = 73,
	Home = 74,
	PageUp = 75,
	Delete = 76,
	End = 77,
	PageDown = 78,
	Right = 79,
	Left = 80,
	Down = 81,
	Up = 82,
	NumLockClear = 83,
	KP_Divide = 84,
	KP_Multiply = 85,
	KP_Minus = 86,
	KP_Plus = 87,
	KP_Enter = 88,
	KP_1 = 89,
	KP_2 = 90,
	KP_3 = 91,
	KP_4 = 92,
	KP_5 = 93,
	KP_6 = 94,
	KP_7 = 95,
	KP_8 = 96,
	KP_9 = 97,
	KP_0 = 98,
	KP_Period = 99,
	NonUSBackslash = 100,
	Application = 101,
	Power = 102,
	KP_Equals = 103,
	F13 = 104,
	F14 = 105,
	F15 = 106,
	F16 = 107,
	F17 = 108,
	F18 = 109,
	F19 = 110,
	F20 = 111,
	F21 = 112,
	F22 = 113,
	F23 = 114,
	F24 = 115,
	Execute = 116,
	Help = 117,
	Menu = 118,
	Select = 119,
	Stop = 120,
	Again = 121,
	Undo = 122,
	Cut = 123,
	Copy = 124,
	Paste = 125,
	Find = 126,
	Mute = 127,
	VolumeUp = 128,
	VolumeDown = 129,
	KP_Comma = 133,
	KP_EqualsAS400 = 134,
	International1 = 135,
	International2 = 136,
	International3 = 137,
	International4 = 138,
	International5 = 139,
	International6 = 140,
	International7 = 141,
	International8 = 142,
	International9 = 143,
	Lang1 = 144,
	Lang2 = 145,
	Lang3 = 146,
	Lang4 = 147,
	Lang5 = 148,
	Lang6 = 149,
	Lang7 = 150,
	Lang8 = 151,
	Lang9 = 152,
	AltErase = 153,
	SysReq = 154,
	Cancel = 155,
	Clear = 156,
	Prior = 157,
	Return2 = 158,
	Separator = 159,
	Out = 160,
	Oper = 161,
	ClearAgain = 162,
	CRSEL = 163,
	EXSEL = 164,
	KP_00 = 176,
	KP_000 = 177,
	ThousandsSeparator = 178,
	DecimalSeparator = 179,
	CurrencyUnit = 180,
	CurrencySubunit = 181,
	KP_LeftParen = 182,
	KP_RightParen = 183,
	KP_LeftBrace = 184,
	KP_RightBrace = 185,
	KP_Tab = 186,
	KP_Backspace = 187,
	KP_A = 188,
	KP_B = 189,
	KP_C = 190,
	KP_D = 191,
	KP_E = 192,
	KP_F = 193,
	KP_Xor = 194,
	KP_Power = 195,
	KP_Percent = 196,
	KP_Less = 197,
	KP_Greater = 198,
	KP_Ampersand = 199,
	KP_DblAmpersand = 200,
	KP_VerticalBar = 201,
	KP_DblVerticalBar = 202,
	KP_Colon = 203,
	KP_Hash = 204,
	KP_Space = 205,
	KP_At = 206,
	KP_Exclam = 207,
	KP_MemStore = 208,
	KP_MemRecall = 209,
	KP_MemClear = 210,
	KP_MemAdd = 211,
	KP_MemSubtract = 212,
	KP_MemMultiply = 213,
	KP_MemDivide = 214,
	KP_PlusMinus = 215,
	KP_Clear = 216,
	KP_ClearEntry = 217,
	KP_Binary = 218,
	KP_Octal = 219,
	KP_Decimal = 220,
	KP_Hexadecimal = 221,
	LCtrl = 224,
	LShift = 225,
	LAlt = 226,
	LGui = 227,
	RCtrl = 228,
	RShift = 229,
	RAlt = 230,
	RGui = 231,
	Mode = 257,
	AudioNext = 258,
	AudioPrev = 259,
	AudioStop = 260,
	AudioPlay = 261,
	AudioMute = 262,
	MediaSelect = 263,
	WWW = 264,
	Mail = 265,
	Calculator = 266,
	Computer = 267,
	AC_Search = 268,
	AC_Home = 269,
	AC_Back = 270,
	AC_Forward = 271,
	AC_Stop = 272,
	AC_Refresh = 273,
	AC_Bookmarks = 274,
	BrightnessDown = 275,
	BrightnessUp = 276,
	DisplaySwitch = 277,
	KbdIllumToggle = 278,
	KbdIllumDown = 279,
	KbdIllumUp = 280,
	Eject = 281,
	Sleep = 282,
	App1 = 283,
	App2 = 284,
	AudioRewind = 285,
	AudioFastforward = 286,
	NumScancodes = 512
}
