precision mediump float;

uniform mat3 clip_matrix;
uniform vec3 clip_translate;
uniform float clip_z_offset;
uniform float clip_z_scale;
uniform float sea_sin;

attribute vec3 position;
attribute vec3 normal;
attribute vec2 texcoord;

varying float vertex_fog;
varying float vertex_sea;
varying vec2 vertex_texcoord;

void main() {
	float sea_range = 2.0;
	float sea_distance = 132.0;
	float sea_low = sea_distance*0.95+sea_sin*sea_range*0.5;
	float height = sqrt(position.y*position.y+position.z*position.z);

	// vec3 wave = normal*sin(time*(texcoord.y+1.0)+texcoord.x*32.0)*clamp(height-sea_distance, 0.0, 1.0);
	vec3 preclip = clip_matrix*position+clip_translate;
	gl_Position = vec4(preclip.x, preclip.y, preclip.z*clip_z_scale+clip_z_offset, preclip.z);
	float fog_far = 200.0;
	vertex_fog = pow(min(length(preclip)/fog_far, 1.0), 2.0);
	vertex_sea = (height-sea_low)/sea_range;
	vertex_texcoord = texcoord;
}
