uniform mat3 clip_matrix;
uniform vec3 clip_translate;
uniform float clip_z_offset;
uniform float clip_z_scale;

attribute vec3 position;
attribute vec2 texcoord;

varying float vertex_fog;
varying float vertex_texcoord;

void main() {
	vec3 preclip = clip_matrix*position+clip_translate;
	gl_Position = vec4(preclip.x, preclip.y, preclip.z*clip_z_scale+clip_z_offset, preclip.z);
	float fog_far = 200.0;
	vertex_fog = pow(min(length(preclip)/fog_far, 1.0), 2.0);
	vertex_texcoord = texcoord.x;
}
